﻿/*
Developed by Kristin Henry (galaxygoo@gmail.com)
This code is available as is, without warranty.

www.underground-flash.com
www.underground-lab.com
August 2008
*/

package {
	
	import flash.utils.Timer;
	import flash.events.TimerEvent;
	import flash.display.Sprite;
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	
	public class Box extends MovieClip{
		
		// declare properties
		//-------------------------------------------------------------------------
		public var xMax;
		public var yMax;
		private var targ;
		private var gen;
		
		private var boxes:Sprite = new Sprite();
		private var icons:Array = new Array();
		
		private var startX;
		private var startY;
		private var W;
		private var H;
		private var w1;
		private var h1;
		private var midW;
		private var midH;
		
		private var myTimer:Timer;
		private var myTimer2:Timer = new Timer(1200, 0);
		private var tCount:Number = 0;
			
		private var mom; 
		private var restart_btn;
		
		
		// contstuctor
		//-------------------------------------------------------------------------
		public function Box(target){
			
			gen = 0;
			w1 = 50;
			
			targ = target;
			W = target.width;
			H = target.height;
			startX = target.x;
			startY = target.y;
			
			xMax = W;
			yMax = H;
		}
		
				
		// methods
		//-------------------------------------------------------------------------
		public function addLines(){
			
			// draw lined up boxes on a grid and drop them
			myTimer = new Timer(70, 0);
			myTimer.addEventListener(TimerEvent.TIMER, drawLines);
			myTimer.start();
		}
				
		//--
		function drawLines(event:TimerEvent):void{		
			
			if(gen == 1){
				
				myTimer2.stop();
				drawBoxes(boxes);
				incGen();
			} else if(gen == 2){
				
				moveBoxes();
				myTimer.stop();	
			} 
		}
		
		//--	
		function drawBoxes(s){
						
			// save path to parent
			mom = targ.parent;
			
			targ.alpha = .8;
						
			var max = 64; // total cells
			var gmax = 8; // max cells in a row of the grid
			for(var i = 0; i<max; i++){
				
				var b = new Cell(i, w1, max, gmax, startX, startY);
				
				// attach to parent clip
				mom.addChild(b);
				
				// save reference of this icon 
				icons.push(b);				
			}
		}
		
		//--
		function moveBoxes(){		
			// add event handler & start the clock 
			var interval = 500;
			myTimer2 = new Timer(interval, 0);
			myTimer2.addEventListener(TimerEvent.TIMER, dropCells);
			myTimer2.start();
		}
		
		function dropCells(event:TimerEvent){
			// at this interval, trigger the animation of one cell in the grid, 
					
			// get number of icons in grid, and check that there are any to drop
			var m = icons.length -1;
			
			if(m >= 0){
				// get random icon to drop
				var i = randRange(0,m, 0)
							
				// trigger the animation function for this icon and remove from array
				icons[i].moveCell();
				icons.splice(i,1);
				
			} else {
								
				// enable restart button
				if(restart_btn){
					restartButtonShow();
				} else {
					restartButtonMake();
				}
				
				// stop timer for selecting and triggering animation of cells
				myTimer2.stop();
				
			}
		}
		
		//--	
		function restartListener(event:MouseEvent){
			restartButtonHide();
			restartGrid();
		}
		
		function restartButtonMake(){
			restart_btn = new restartButton(200, 60, 100, 140);
			restart_btn.addEventListener(MouseEvent.MOUSE_UP, restartListener);						
			this.addChild(restart_btn);
		}
		
		function restartButtonHide(){
			restart_btn.visible = false;
		}
		
		function restartButtonShow(){
			restart_btn.visible = true;
		}
		
		function restartGrid(){
			gen = 1;
			myTimer.start();	
		}
		
		//--
		public function incGen(){
			if(gen > 2){
				gen = 0;
			} else {
				gen = gen + 1;
			}
			
		}
		
		//======================================
		// based on function from Joey Lott's ActionScript Cookbook
		function randRange(minNum, maxNum, decPl){
			
			var rangeDiff = (maxNum - minNum) * Math.pow(10, decPl) + 1;
			var randVal = Math.random() * rangeDiff;
			randVal = Math.floor(randVal);
			randVal /= Math.pow(10, decPl);
			randVal += minNum;
	
			return randVal;
		}
		
	}
}